// https://github.com/etherkit/Si5351Arduino
// http://nt7s.com/2014/06/si5351-libraries-and-breakout-board/
// http://m0xpd.blogspot.co.uk/ 

#include "si5351.h"
#include "Wire.h"
#include <Rotary.h>

Si5351 si5351;
Rotary r = Rotary(2,3); // sets the pins the rotary encoder uses.  Must be interrupt pins.

long frq = 14100000;    // start frequency in Hz
long frq_old; 
int increment = 100;    // VFO steps in Hz

//////////////////////////////////////////////////////////////
void setup()
{
  PCICR |= (1 << PCIE2);
  PCMSK2 |= (1 << PCINT18) | (1 << PCINT19);
  sei();

  // Start serial and initialize the Si5351
  Serial.begin(9600);
  si5351.init(SI5351_CRYSTAL_LOAD_8PF);

  // Set CLK0 to output 14 MHz with a fixed PLL frequency
  si5351.set_pll(SI5351_PLL_FIXED, SI5351_PLLA);
  si5351.set_freq(frq, SI5351_PLL_FIXED, SI5351_CLK0);
}

////////////////////////////////////////////////////////////
ISR(PCINT2_vect) {
  unsigned char result = r.process();
  if (result) {    
    if (result == DIR_CW){frq=frq+increment;}
    else {frq=frq-increment;};       
  }
}

////////////////////////////////////////////////////////////////
void loop()
{
  if (frq != frq_old)  {    
  si5351.set_pll(SI5351_PLL_FIXED, SI5351_PLLA);
  si5351.set_freq(frq, SI5351_PLL_FIXED, SI5351_CLK0);
  Serial.println(frq);
  frq_old = frq;
 } 
}



